//+----------------------------------------------------------------+
//| TestEA                                                         |
//| IntraDay Scalping                                              |
//| http://www.forex-tsd.com/ideas-suggestions/16059-scalp-freedom-10-20-pips-trade-guaranteed.html
//+----------------------------------------------------------------+ 

// Input Variables 
 extern string EAVariables="";
 extern string CurSymbol = "EURUSD"; 
 extern int    MaxSpread = 50;    // Max spread in points
 extern int    Slippage  =  5;    // Max slippage in points
 extern int    MaxOrders =  1;    // Max orders open
 extern int    StartTime = 07;    // Start time hours
 extern int    EndTime=    20;   // End time hours
 extern double MultiLotSize = 0.01;  // Multiplie Lot Size

// Remaining 
 int Ticket,Total;
 double Lot,ClosingTime, Spread;
 bool FirstTime=true;

// Indicator Objects
#property indicator_separate_window
#property indicator_minimum -1
#property indicator_buffers 8
#property indicator_color1 Red
#property indicator_color2 Blue
#property indicator_color3 Red
#property indicator_color4 Blue
#property indicator_color5 Red
#property indicator_color6 Blue
#property indicator_color7 Red
#property indicator_color8 Blue

// Buffers
double buf4_up[];
double buf4_down[];
double buf3_up[];
double buf3_down[];
double buf2_up[];
double buf2_down[];
double buf1_up[];
double buf1_down[];

// Freedom Parameters
extern int Period_1 = PERIOD_M5;
extern int Period_2 = PERIOD_M15;
extern int Period_3 = PERIOD_M30;
extern int Period_4 = PERIOD_H1;

// Remaining
extern double Gap = 1; // Gap between the lines of bars
extern bool AutoDisplay = false;
string shortname = "";
bool firstTime = true;
int UniqueNum = 228; 
 
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   SetAutoDisplay();
 
   shortname = "# Forex Freedom("+Period_1+","+Period_2+","+Period_3+","+Period_4+")";
   firstTime = true;
   
   IndicatorShortName(shortname);

   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0,110);
   SetIndexBuffer(0,buf4_up);
   SetIndexEmptyValue(0,0.0);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1,110);
   SetIndexBuffer(1,buf4_down);
   SetIndexEmptyValue(1,0.0);
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,110);
   SetIndexBuffer(2,buf3_up);
   SetIndexEmptyValue(2,0.0);
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,110);
   SetIndexBuffer(3,buf3_down);
   SetIndexEmptyValue(3,0.0);
   SetIndexStyle(4,DRAW_ARROW);
   SetIndexArrow(4,110);
   SetIndexBuffer(4,buf2_up);
   SetIndexEmptyValue(4,0.0);
   SetIndexStyle(5,DRAW_ARROW);
   SetIndexArrow(5,110);
   SetIndexBuffer(5,buf2_down);
   SetIndexEmptyValue(5,0.0);
   SetIndexStyle(6,DRAW_ARROW);
   SetIndexArrow(6,110);
   SetIndexBuffer(6,buf1_up);
   SetIndexEmptyValue(6,0.0);
   SetIndexStyle(7,DRAW_ARROW);
   SetIndexArrow(7,110);
   SetIndexBuffer(7,buf1_down);
   SetIndexEmptyValue(7,0.0);

   return(0);
  }

  
int start()
  { 
  
//+----------------------------------------------------------------+
//|              Everything For the Freedom Indicator              |
//+----------------------------------------------------------------+    
   int    counted_bars=IndicatorCounted();
   int i=0, y15m=0, y4h=0, y1h=0, y30m=0, yy;
   int limit=Bars-counted_bars;
   datetime TimeArray_4H[], TimeArray_1H[], TimeArray_30M[], TimeArray_15M[];
   
      if (firstTime || NewBar())
        {
      firstTime = false;
      int win = UniqueNum; // WindowFind(shortname);
      double dif = Time[0] - Time[1];
      for (int ii=ObjectsTotal()-1; ii>-1; ii--)
      {
         if (StringFind(ObjectName(ii),"FF_"+win+"_") >= 0)
            ObjectDelete(ObjectName(ii));
         else 
            ii=-1;
      }
      
      double shift = 0.2;
      for (ii=0; ii<4; ii++)
      {  
         string txt = "??";
         double gp;
         switch (ii)
         {
            case 0: txt = tf2txt(Period_1);  gp = 1 + shift;         break;
            case 1: txt = tf2txt(Period_2);  gp = 1 + Gap + shift;   break;
            case 2: txt = tf2txt(Period_3);  gp = 1 + Gap*2 + shift; break;
            case 3: txt = tf2txt(Period_4);  gp = 1 + Gap*3 + shift; break;
         }
         string name = "FF_"+win+"_"+ii+"_"+txt;
         ObjectCreate(name, OBJ_TEXT, WindowFind(shortname), iTime(NULL,0,0)+dif*3, gp);
         ObjectSetText(name, txt,8,"Arial", Black);
      }
   }
   
   ArrayCopySeries(TimeArray_4H,MODE_TIME,Symbol(),Period_4); 
   ArrayCopySeries(TimeArray_1H,MODE_TIME,Symbol(),Period_3); 
   ArrayCopySeries(TimeArray_30M,MODE_TIME,Symbol(),Period_2);
   ArrayCopySeries(TimeArray_15M,MODE_TIME,Symbol(),Period_1); 
      
   for(i=0, y15m=0,  y4h=0,  y1h=0,  y30m=0;i<limit;i++)
   {
      if (Time[i]<TimeArray_15M[y15m]) y15m++;
      if (Time[i]<TimeArray_4H[y4h])   y4h++;
      if (Time[i]<TimeArray_1H[y1h])   y1h++;
      if (Time[i]<TimeArray_30M[y30m]) y30m++;

      for (int tf = 0; tf < 4; tf++)
      {
         int prd;
         switch (tf)
         {
            case 0: prd = Period_1; yy = y15m;  break;
            case 1: prd = Period_2; yy = y30m;  break;
            case 2: prd = Period_3;  yy = y1h;   break;
            case 3: prd = Period_4;  yy = y4h;   break;
         }
         
         double cci = iCCI(NULL, prd, 50,PRICE_TYPICAL, yy);
         double dUp = EMPTY_VALUE; //   iCustom(NULL, prd, "SuperTrend", false, 1, yy);
         double dDn = EMPTY_VALUE; //   iCustom(NULL, prd, "SuperTrend", false, 0, yy);
         
         if (cci < 0) dUp = 1; else dDn = 1;
         
         switch (tf)
         {
            case 0: if (dUp == EMPTY_VALUE)  buf1_down[i] = 1; else buf1_up[i] = 1; break;
            case 1: if (dUp == EMPTY_VALUE)  buf2_down[i] = 1 + Gap * 1; else buf2_up[i] = 1 + Gap * 1; break;
            case 2: if (dUp == EMPTY_VALUE)  buf3_down[i]  = 1 + Gap * 2; else buf3_up[i]  = 1 + Gap * 2; break;
            case 3: if (dUp == EMPTY_VALUE)  buf4_down[i]  = 1  + Gap * 3; else buf4_up[i]  = 1 + Gap * 3; break;
         }
                  
      }

   }
           
//+----------------------------------------------------------------+
//|                      Condition SubFunction                     |
//+----------------------------------------------------------------+                      
 if (OrdersTotal()==0 && TradingTime() || FirstTime)  
   {
    FirstTime=false;      
    if(SpreadFinder() < MaxSpread )
      {
       if(!AccountFreeMarginCheck(Symbol(),OP_SELL,LotSize())<=0)
         { 
           if(buf1_up[i]==1 && buf2_up[i]==1 && buf3_up[i]==1) 
            {      
             OpenLong(LotSize());
             return(0); 
            }
         }
      }      
     if(SpreadFinder() < MaxSpread)
       {
        if(!AccountFreeMarginCheck(Symbol(),OP_SELL,LotSize())<=0)
          {
           if(buf1_down[i]==1 && buf2_down[i]==1 && buf3_down[i]==1)  
             {            
              OpenShort(LotSize());
              return(0);
             }  
          }
      }                      
    } 
      
//+----------------------------------------------------------------+
//|                      Control SubFunction                       |
//+----------------------------------------------------------------+     
   if(OrdersTotal()==1)
   {
    OrderSelect(0, SELECT_BY_POS);
    if(OrderType()==OP_BUY)
        { 
         if(buf1_down[i]==1 || buf2_down[i]==1 || buf3_down[i]==1)
            {        
            OrderClose(Ticket,LotSize(),Bid,Slippage,Red);
            return(0);                      
            }
        }

    if(OrderType()==OP_SELL)
        {
         if(buf1_up[i]==1 || buf2_up[i]==1 || buf3_up[i]==1)
            {      
            OrderClose(Ticket,LotSize(),Ask,Slippage,Green);      
            return(0);                      
            }

        }           
    }
   
  return(0);   
//End Start Function
 }
 
//+----------------------------------------------------------------+
//|                         ISNEWBAR Function                      |
//+----------------------------------------------------------------+
bool NewBar()
{
   static datetime dt = 0;
   
   if (Time[0] != dt)
   {
      dt = Time[0];
      return(true);
   }
   return(false);
}

//+----------------------------------------------------------------+
//|                         ISTradingTime                          |
//+----------------------------------------------------------------+
bool TradingTime()
   {
    bool X=false;
    if(Hour()>= (StartTime)  && Hour() <EndTime)
        X=true;
    return(X);
    }

//+----------------------------------------------------------------+
//|                   Freedom Indicator Part 2                     |
//+----------------------------------------------------------------+

string tf2txt(int tf)
{
   if (tf == PERIOD_M1)    return("M1");
   if (tf == PERIOD_M5)    return("M5");
   if (tf == PERIOD_M15)    return("M15");
   if (tf == PERIOD_M30)    return("M30");
   if (tf == PERIOD_H1)    return("H1");
   if (tf == PERIOD_H4)    return("H4");
   if (tf == PERIOD_D1)    return("D1");
   if (tf == PERIOD_W1)    return("W1");
   if (tf == PERIOD_MN1)    return("MN1");
   
   return("??");
}

void SetValues(int p1, int p2, int p3, int p4)
{
   Period_1 = p1;   Period_2 = p2; Period_3 = p3; Period_4 = p4; 
}


void SetAutoDisplay()
{
   if (AutoDisplay)
   {
      switch (Period())
      {
         case PERIOD_M1  :  SetValues(PERIOD_M1,  PERIOD_M5, PERIOD_M15,PERIOD_M30); break;
         case PERIOD_M5  :  SetValues(PERIOD_M5,  PERIOD_M15,PERIOD_M30,PERIOD_H1);  break;
         case PERIOD_M15 :  SetValues(PERIOD_M5,  PERIOD_M15,PERIOD_M30,PERIOD_H1);  break;
         case PERIOD_M30 :  SetValues(PERIOD_M5, PERIOD_M15,PERIOD_M30, PERIOD_H1);  break;
         case PERIOD_H1  :  SetValues(PERIOD_M15, PERIOD_M30,PERIOD_H1, PERIOD_H4);  break;
         case PERIOD_H4  :  SetValues(PERIOD_M30, PERIOD_H1, PERIOD_H4, PERIOD_D1);  break;
         case PERIOD_D1  :  SetValues(PERIOD_H1,  PERIOD_H4, PERIOD_D1, PERIOD_W1);  break;
         case PERIOD_W1  :  SetValues(PERIOD_H4,  PERIOD_D1, PERIOD_W1,PERIOD_MN1);  break;
         case PERIOD_MN1 :  SetValues(PERIOD_H4,  PERIOD_D1, PERIOD_W1,PERIOD_MN1);  break;
      }
   }
      
}

//+----------------------------------------------------------------+
//| This function calculates spread in pippettes                   |
//+----------------------------------------------------------------+
double SpreadFinder()
   {
    if (StringFind(Symbol(), "JPY") > 0) 
      Spread = (Ask-Bid)*1000;
    else 
      Spread = (Ask-Bid)*100000;
    return(NormalizeDouble(Spread,1));
   }
        
//+----------------------------------------------------------------+
//| This function opens a long position                            |
//+----------------------------------------------------------------+
int OpenLong(double Lots)
{
  Ticket=OrderSend(CurSymbol,OP_BUY,Lots,Ask,Slippage,0,0,"",0,0,Green);                         
  if(Ticket>0)
    {     
    if(OrderSelect(Ticket,SELECT_BY_TICKET,MODE_TRADES))
      {
        return(0);
      }
    else
      {
        Print("OpenLong(),OrderSelect() - returned an error : ",GetLastError()); 
        return(-1);
      }   
  }
  else 
  {
    Print("Error opening Buy order : ",GetLastError()); 
    return(-1);
  }
}
 
//+----------------------------------------------------------------+
//| This function opens a short position                           |
//+----------------------------------------------------------------+
int OpenShort(double Lots)
{ 
  Ticket=OrderSend(CurSymbol,OP_SELL,Lots,Bid,Slippage,0,0,"",0,0,Red);                  
  if(Ticket>0)
  {
    if(OrderSelect(Ticket,SELECT_BY_TICKET,MODE_TRADES))
      {
        return(0);
      }
      else
         {
           Print("OpenShort(),OrderSelect() - returned an error : ",GetLastError()); 
           return(-1);
         }    
  }
 
   else 
  {
    Print("Error opening Sell order : ",GetLastError()); 
    return(-1);
  }
}
 
//+----------------------------------------------------------------+
//| This function calculates lotsize                               |
//+----------------------------------------------------------------+ 
double LotSize()
{
if (AccountBalance()>=50) Lot=0.02;
if (AccountBalance()>=75) Lot=0.03;
if (AccountBalance()>=100) Lot=0.04;
if (AccountBalance()>=125) Lot=0.05;
if (AccountBalance()>=150) Lot=0.06;
if (AccountBalance()>=175) Lot=0.07;
if (AccountBalance()>=200) Lot=0.08;
if (AccountBalance()>=225) Lot=0.09;
if (AccountBalance()>=250) Lot=0.1;
if (AccountBalance()>=275) Lot=0.11;
if (AccountBalance()>=300) Lot=0.12;
if (AccountBalance()>=325) Lot=0.13;
if (AccountBalance()>=350) Lot=0.14;
if (AccountBalance()>=375) Lot=0.15;
if (AccountBalance()>=400) Lot=0.16;
if (AccountBalance()>=425) Lot=0.17;
if (AccountBalance()>=450) Lot=0.18;
if (AccountBalance()>=475) Lot=0.19;
if (AccountBalance()>=500) Lot=0.20;
if (AccountBalance()>=550) Lot=0.24;
if (AccountBalance()>=600) Lot=0.26;
if (AccountBalance()>=650) Lot=0.28;
if (AccountBalance()>=700) Lot=0.30;
if (AccountBalance()>=750) Lot=0.32;
if (AccountBalance()>=800) Lot=0.34;
if (AccountBalance()>=850) Lot=0.36;
if (AccountBalance()>=900) Lot=0.38;
if (AccountBalance()>=1000) Lot=0.4;
if (AccountBalance()>=1500) Lot=0.6;
if (AccountBalance()>=2000) Lot=0.8;
if (AccountBalance()>=2500) Lot=1.0;
if (AccountBalance()>=3000) Lot=1.2;
if (AccountBalance()>=3500) Lot=1.4;
if (AccountBalance()>=4000) Lot=1.6;
if (AccountBalance()>=4500) Lot=1.8;
if (AccountBalance()>=5000) Lot=2.0;
if (AccountBalance()>=5500) Lot=2.2;
if (AccountBalance()>=6000) Lot=2.4;
if (AccountBalance()>=7000) Lot=2.8;
if (AccountBalance()>=8000) Lot=3.2;
if (AccountBalance()>=9000) Lot=3.6;
if (AccountBalance()>=10000) Lot=4.0;
if (AccountBalance()>=15000) Lot=6.0;
if (AccountBalance()>=20000) Lot=8.0;
if (AccountBalance()>=30000) Lot=12;
if (AccountBalance()>=40000) Lot=16;
if (AccountBalance()>=50000) Lot=20;
if (AccountBalance()>=60000) Lot=24;
if (AccountBalance()>=70000) Lot=28;
if (AccountBalance()>=80000) Lot=32;
if (AccountBalance()>=90000) Lot=36;
if (AccountBalance()>=100000) Lot=40;
if (AccountBalance()>=200000) Lot=80;

double LotTotal=(Lot*MultiLotSize);
return(NormalizeDouble(LotTotal,2));
}
    
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   SetAutoDisplay();
   
   shortname = "# Forex Freedom("+Period_1+","+Period_2+","+Period_3+","+Period_4+")";
   firstTime = true;
//----
   return(0);
  }